Primeira Lista de Exerccios
============================

Introduo
----------

Baixe o [projeto da lista](lista1.zip), que est preparado para funcionar tanto com o SBT quanto
com o eclipse, e implemente as funes correspondentes a cada questo do exerccio. Depois envie
apenas o arquivo `package.scala` com os fontes da sua implementao, usando o formulrio no final
dessa pgina.

Questo 1 - Tringulo de Pascal
-------------------------------

O *tringulo de Pascal*  uma representao grfica dos coeficientes dos binmios `(x+y)^n`.
Cada linha do tringulo lista os coeficientes do seu respectivo binnio (contado a partir de 0).

![Tringulo de Pascal](http://upload.wikimedia.org/math/6/8/7/68716cad06e288afb1ed5266c711b66b.png)

Os nmeros nos lados do tringulo so sempre 1, e cada nmero do interior do tringulo  a soma dos dois
nmeros acima dele. Implemente uma funo em Scala que calcula coeficientes do tringulo de Pascal, dada
sua posio no tringulo, contada a partir de 0:

    def pascal(col: Int, lin: Int): Int = ???

Questo 2 - Parnteses Balanceados
----------------------------------

Escreva uma funo que verifica se os parnteses presentes em uma lista de caracteres esto balanceados. Note que
no basta contar o nmero de `(` e `)`, pois listas como `List(')','(')` e `List('(',')',')','(')` no so
balanceadas.

    def balanceado(l: List[Char]): Boolean = ???

Para facilitar o teste use a funo `toList` de Scala, que converte uma string em uma lista de caracteres:

    > balanceado("so (um (teste) (da funcao) ) ".toList)
    res0: Boolean = true

Use recurso final na sua resposta.

Questo 3 - Quicksort
---------------------

A ideia do algoritmo de ordenao *quicksort*  bem simples: escolhemos um elemento *piv* de uma lista
(o primeiro elemento, por exemplo), e *particionamos* a lista usando esse piv em duas listas. A primeira
lista tem todos os elementos menores ou iguais ao piv, e a segunda lista todos os elementos maiores que
o piv. Ento basta ordenar essas duas listas e concatenar o resultado.

Escreva a funo `particao` que particiona uma lista dado um elemento piv:

    def particao(l: List[Int], pivo: Int): (List[Int], List[Int]) = ???

Escreva a funo `quicksort` para ordenar uma lista, usando a funo de partio que voc escreveu:

    def quicksort(l: List[Int]): List[Int] = ???

Questo 4 - CR acumulado
------------------------

Podemos representar as notas de um aluno da UFRJ em dado semestre como uma lista de pares
*(nota,creditos)*:

    > val sem1 = List((9.5,3),(7.3,4),(5.0,3),(4.0,4))
    sem1: List[(Double, Int)] = List((9.5,3), (7.3,4), (5.0,3), (4.0,4))

O coeficiente de rendimento (CR) de um aluno em determinado semestre  a mdia ponderada
de suas notas, com o peso de cada uma sendo o nmero de crditos da matria.

Escreva a funo `crSemestre` que recebe as notas do aluno no semestre e retorna seu
CR para aquele semestre e o nmero de crditos que o aluno cursou:

    def crSemestre(notas: List[(Double, Int)]): (Double, Int) = ???

As notas do aluno durante o curso podem ser representadas como uma lista de listas de notas
para cada semestre. O *CR acumulado* de um aluno em determinado momento do curso  uma mdia
ponderada dos CRs de cada semestre, com o peso sendo o nmero de crditos cursado naquele
semestre.

Escreva a funo `crsAcumulados` que recebe a lista de listas de notas para cada semestre e
retorna uma lista com o CR acumulado para o aluno aps cada semestre (o CR acumulado
aps o primero semestre  o CR do primeiro semestre), assim como o total de crditos cursados
at aquele momento.

    def crsAcumulados(semestres: List[List[(Double, Int)]]): (List[Double], Int) = ???

Entrega da lista
----------------

Use o formulrio abaixo para enviar a sua lista. Lembre de enviar apenas o arquivo `package.scala` que
voc modificou. O prazo para envio  sexta-feira, dia 26/04/2013.

<script type="text/javascript" src="http://form.jotformz.com/jsform/31014701317641">
// dummy
</script>
